import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTFwd extends ASTNode {

    String ch1;
    String ch2;

    //ASTType typeCh1;
    ASTType typeCh2;

    public ASTFwd(String _ch1, String _ch2) {
	ch1 = _ch1;
	ch2 = _ch2;
    }
    
    public void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
	 throw new Exception ("Unexpected call editASTInsertUse"); // never called
    }

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		throw new Exception ("Unexpected call: ASTInsertCall"); // never called
	}

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		throw new Exception ("Unexpected call: ASTInsertWhyNot"); // never called
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception {
		throw new Exception ("Unexpected call.");
	}

		public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	if (_ch.equals(ch1) || _ch.equals(ch2)) 
	    throw new Exception ("Unexpected call: ASTInsertWhyNot"); // never called
	return this.ASTweakeningHere(_ch,exp);
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {


		ASTType t1 = ed.find(ch1);
		ASTType t2 = ed.find(ch2);


		ASTType tt1 = t1.unfoldType(ep);
		tt1 = ASTType.unfoldRec(tt1);



		ASTType tt2 = t2.unfoldType(ep);;
		tt2 = ASTType.unfoldRec(tt2);
		typeCh2 = tt2;



		ASTType tdual =	tt2.dual(ep);

		// System.out.println(tdual.toStr(ep) + " " + tt1.toStr(ep));

		if(!tt1.equalst(tdual,ep, true, new Trail())){
			/*System.out.println("DEBUG FWD non dual types. "
					+ ch1+ ":" + tt1.toStr(ep) + " and "+ch2+":"+tt2.toStr(ep) + ". Dual type of ch2 = " + tdual.toStr(ep));*/
			if(tt1 instanceof ASTCoAffineT){
				ASTCoAffineT tyco = (ASTCoAffineT)tt1;
				ed.upd(ch1, tyco.getin());

				ASTType cont = tyco.getin().unfoldType(ep);
				cont = ASTType.unfoldRec(cont);
				Boolean disposableCont = (cont instanceof ASTUsageT) || (cont instanceof ASTCoAffineT)
						|| (cont instanceof ASTWhyT);

				this.getanc().ASTInsertUse(ch1,this, disposableCont);
				//System.out.println("inferred USE");
				this.typecheck(ed,eg,ep);
			}
			else if(tt2 instanceof ASTCoAffineT){
				ASTCoAffineT tyco = (ASTCoAffineT)tt2;
				ed.upd(ch2, tyco.getin());
				ASTType cont = tyco.getin().unfoldType(ep);
				cont = ASTType.unfoldRec(cont);
				Boolean disposableCont = (cont instanceof ASTUsageT) || (cont instanceof ASTCoAffineT)
						|| (cont instanceof ASTWhyT);

				this.getanc().ASTInsertUse(ch2,this, disposableCont);				//System.out.println("inferred USE");
				this.typecheck(ed,eg,ep);
			}
			else throw new TypeError("FWD "+ch1+":"+tt1.toStr(ep)+" and "
					+ch2+":"+tt2.toStr(ep)+" non dual types.");
		} else{
			ed.upd(ch1,null);
			ed.upd(ch2,null);
		}

	}

	public Set<String> fn(Set<String> s) {
		s.add(ch1);
		s.add(ch2);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch1);
		s.add(ch2);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	    return this;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch1)
			ch1 = x;
		if(y == ch2);
			ch2 = x;
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception {

	    // System.out.println("FWD START "+ch1+" : "+ch2);

		//when forwarding a cell, make sure the cell is on channel ch1
		ASTType typeCh2i = typeCh2.unfoldType(ep);
		String ch1i, ch2i;


		if(typeCh2i instanceof ASTCellT || typeCh2i instanceof ASTCellLT
				|| typeCh2i instanceof ASTCellBT || typeCh2i instanceof ASTCellBLT ) {
			ch1i = ch2;
			ch2i = ch1;
		}
		else{
			ch1i = ch1;
			ch2i = ch2;
		}


		// System.out.println("FWD "+ch1i+" : "+ch2i+" : "+typeCh2i);


	try {	
	LinSession session1 = (LinSession)ed.find(ch1i);
	LinSession session2 = (LinSession)ed.find(ch2i);

	session1.setFwdSession(session2);

	// System.out.println("Set fwd "+ session1.getId() + " -> " + session2.getId());
	
	logger.info("Set fwd "+ session1.getId() + " -> " + session2.getId());


	} catch (TypeError ee) {
		    System.out.println("FWD ERR "+ee.msg);
		    throw new Exception();
		}
	
		}
	}
