public class ASTNotT extends ASTType {
    ASTType t;
    
    public ASTNotT(ASTType _t) {
	t = _t;
    }

    public ASTType getin() {
	return t;
    }

    public boolean equalst(ASTType tt, Env<EnvEntry> e, boolean lit, Trail trail) throws Exception
    {
	// System.out.println(lit+" EQST "+this.toStr(e) + " == " + tt.toStr(e));
     if(!lit) {
	 if (!(tt instanceof ASTNotT)) return false;
       	    ASTType tn = ((ASTNotT)tt).getin();
	    return tn.equalst(t, e, lit, trail);
     } else {
	 	if (tt instanceof ASTIdT) {
		    // System.out.println("HEREX "+tt);

	 	    return tt.equalst(this,e,true,trail);
	 	}
	 	    else
		{
	    ASTType tn = tt.dual(e);
        return tn.equalst(t, e, lit, trail);
	    }
	}
    }


    public void kindcheck(Env<EnvEntry> e) throws Exception
    {
	t.kindcheck(e);
    }

    public ASTType dual(Env<EnvEntry> e) throws Exception {
        // System.out.println("+DUAL NOT  >> "+t);
	return t;
    }

public ASTType unfoldType(Env<EnvEntry> e) throws Exception
    {
	/* PR: previosuly
	ASTTypeDef astt = null;
	String ss = null;
	if (t instanceof ASTIdT) {
	    ASTIdT tid = (ASTIdT)t;
	    if (!tid.haspars){ // cache negation of parameter less (constant) type defs (in particular rec / corec defs)
	    ss = tid.getid();
	    EnvEntry ee = e.find (ss);
	    if (ee instanceof TypeDefEntry) {
		TypeDefEntry et = (TypeDefEntry)ee;
		astt = et.getTypeDef(); // broken I am not using this flags anymore
		if (astt.rec) { astt.corec=true; astt.rec=false;};
		if (astt.corec) { astt.corec=false; astt.rec=true;};
		if (astt.getRec()) {
		    if (astt.getDual()!=null) {
			// e.crawl();
			return astt.getDual();
		    }
		    else {
			ASTType ty=t.unfoldType(e);
		        ty=ty.dual(e);
			astt.setDual(ty);
			return ty;
		    }
	       } 
	    }
	}
	};*/
		ASTType ty=t.unfoldType(e);
		ty=ty.dual(e);
		return ty;
    }

    public String toStr(Env<EnvEntry> e) throws Exception {
	return "~"+t.toStr(e);
    }

    public  ASTType subst(Env<ASTType> e) {
	return new ASTNotT(t.subst(e));
    }
    
}
