import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTRelease extends ASTNode {
    String chr;

    public ASTRelease (String _chr) {
	chr = _chr;
    }

    public void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
	 throw new Exception ("Unexpected call editASTInsertUse"); // never called
    }

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		throw new Exception ("Unexpected call.");
	}

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		throw new Exception ("Unexpected call: ASTInsertWhyNot"); // never called
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		throw new Exception ("Unexpected call: ASTInsertCall"); // never called
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	return this.ASTweakeningTerm(_ch,exp);		
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.inferUses(chr,ed,ep);

		ASTType ty = ed.find(chr);
	    ty = ty.unfoldType(ep);
	    ty = ASTType.unfoldRec(ty);
	    if (ty instanceof ASTUsageT) {
			ASTUsageT tyr = (ASTUsageT) ty;
			ed.upd(chr, null);
		} else if (ty instanceof ASTUsageBT){
			ASTUsageBT tyr = (ASTUsageBT) ty;
			ed.upd(chr, null);
		}
	    else throw new TypeError("RELEASE: "+chr+" is neither of USAGE nor of USAGE! type.");
    }

    public Set<String> fn(Set<String> s) {
		s.add(chr);
		return s;
    }

	public Set<String> fnLinear(Set<String> s) {
		s.add(chr);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) { return this; }

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chr)
			chr = x;
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Cell cell = (Cell) ed.find(chr);
		cell.free();
		logger.info("RELEASE usage on cell "+cell.getId());
	}

}
