import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTDiscard extends ASTNode {
    String chr;

    public ASTDiscard (String _chr) {
        chr = _chr;
    }

    public void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
	 throw new Exception ("Unexpected call editASTInsertUse"); // never called
    }

    public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
        throw new Exception ("Unexpected call: ASTInsertCall"); // never called
    }

    public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception {
        throw new Exception ("Unexpected call.");
    }

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
    {
        throw new Exception ("Unexpected call: ASTInsertWhyNot"); // never called
    }

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	return this.ASTweakeningTerm(_ch,exp);		
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
        ASTType ty = ed.find(chr);
        ty = ty.unfoldType(ep);
 	ty = ASTType.unfoldRec(ty);
       if (ty instanceof ASTCoAffineT) {
            ASTCoAffineT tyr = (ASTCoAffineT)ty;
            ed.upd(chr, null);
        } else throw new TypeError("DISCARD: "+chr+" is not of COAFFINE type: found: "+ty.toStr(ep));
    }

    public Set<String> fn(Set<String> s) {
        s.add(chr);
        return s;
    }

    public Set<String> fnLinear(Set<String> s) {
        s.add(chr);
        return s;
    }

        public ASTNode subst(Env<ASTType> e) {
	    return this;
    }

    public void subs(String x, String y){// implements x/y (substitutes y by x)
        if(y == chr)
            chr = x;
    }

    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
        Channel channel = (Channel) ed.find(chr);
        channel.send("DISCARD");
        logger.info("DISCARD session " + channel.getId());
    }
    
    	public void show()  {
	    System.out.println(this+" "+anc);
	}

}
